program biquadr;	// 2010-03-11  
{$APPTYPE    CONSOLE}
uses math, SysUtils, StrUtils,
	 common, matr;
type
	biq = array[0..8] of extended;

//------------------------------------------------------------------------------
function biquadrTest1( b: biq):boolean;
var p: array[0..5] of extended;
    x, sg, f: extended;
    n:  integer;

begin
    p[0]:=4*b[1]*b[6]*b[6]+b[3]*b[3]*b[7]-2*b[3]*b[4]*b[6];
    p[1]:=2*b[6]*(4*b[2]*b[6]-2*b[3]*b[5]+4*b[1]*b[7]-b[4]*b[4])+2*b[3]*b[3]*b[8];
    p[2]:=2*b[6]*(8*b[2]*b[7]-3*b[4]*b[5]+4*b[1]*b[8])+b[7]*(4*b[1]*b[7]-2*b[3]*b[5]-b[4]*b[4])+2*b[3]*b[4]*b[8];
    p[3]:=4*b[6]*(4*b[2]*b[8]-b[5]*b[5])+4*b[7]*(2*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])-2*b[4]*b[5];
    p[4]:=2*b[8]*(8*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])+b[5]*(4*b[4]-3*b[5]*b[7]);
    p[5]:=8*b[2]*b[8]*b[8]-2*b[5]*b[5]*b[8];

    result := true;
    sg:=sign(p[0]);
    for n:= 1 to 60 do
         begin
           x:=n/60.0;
           f:= p[0]+p[1]*x+p[2]*x*x+p[3]*x*x*x+p[4]*x*x*x*x+p[5]*x*x*x*x*x;
         if f*sg<=0 then  begin
         result := false;
         exit;
         end
      end
  end;

//------------------------------------------------------------------------------
function biquadrTest9( b: biq):boolean;
var q: array[0..5] of extended;
    x, sg, f: extended;
    n:  integer;

begin
    q[0]:=4*b[3]*b[2]*b[6]+b[1]*b[1]*b[5]-2*b[1]*b[4]*b[2];
    q[1]:=2*b[2]*(4*b[2]*b[6]-2*b[1]*b[7]+4*b[3]*b[5]-b[4]*b[4])+2*b[1]*b[1]*b[8];
    q[2]:=2*b[2]*(8*b[6]*b[5]-3*b[4]*b[7]+4*b[3]*b[8])+b[5]*(4*b[3]*b[5]-2*b[1]*b[7]-b[4]*b[4])+2*b[1]*b[4]*b[8];
    q[3]:=4*b[2]*(4*b[6]*b[8]-b[7]*b[7])+4*b[5]*(2*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])-2*b[4]*b[7];
    q[4]:=2*b[8]*(8*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])+b[7]*(4*b[4]-3*b[5]*b[7]);
    q[5]:=8*b[6]*b[8]*b[8]-2*b[7]*b[7]*b[8];

    result := true;
    sg:=sign(q[0]);
    for n:= 1 to 60 do
         begin
           x:=n/60.0;
           f:= q[0]+q[1]*x+q[2]*x*x+q[3]*x*x*x+q[4]*x*x*x*x+q[5]*x*x*x*x*x;
         if f*sg<=0 then  begin
         result := false;
         exit;
         end
      end
  end;
//------------------------------------------------------------------------------
function biquadrTest10( b: biq):boolean;

begin
	result := biquadrTest1(b) or biquadrTest9(b) ;
end;

//------------------------------------------------------------------------------
function biquadrTest2( b: biq):boolean;
var p: array[0..5] of extended;

begin
    p[0]:=4*b[1]*b[6]*b[6]+b[3]*b[3]*b[7]-2*b[3]*b[4]*b[6];
    p[1]:=2*b[6]*(4*b[2]*b[6]-2*b[3]*b[5]+4*b[1]*b[7]-b[4]*b[4])+2*b[3]*b[3]*b[8];
    p[2]:=2*b[6]*(8*b[2]*b[7]-3*b[4]*b[5]+4*b[1]*b[8])+b[7]*(4*b[1]*b[7]-2*b[3]*b[5]-b[4]*b[4])+2*b[3]*b[4]*b[8];
    p[3]:=4*b[6]*(4*b[2]*b[8]-b[5]*b[5])+4*b[7]*(2*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])-2*b[4]*b[5];
    p[4]:=2*b[8]*(8*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])+b[5]*(4*b[4]-3*b[5]*b[7]);
    p[5]:=8*b[2]*b[8]*b[8]-2*b[5]*b[5]*b[8];

 if (p[0]>0)and(p[1]>0)and(p[2]>0)and(p[3]>0)and(p[4]>0)and(p[5]>0) then
    begin
    	result := true;
    end
 else result := false;
end;
//------------------------------------------------------------------------------
function biquadrTest3( b: biq):boolean;
var p: array[0..5] of extended;

begin
    p[0]:=4*b[1]*b[6]*b[6]+b[3]*b[3]*b[7]-2*b[3]*b[4]*b[6];
    p[1]:=2*b[6]*(4*b[2]*b[6]-2*b[3]*b[5]+4*b[1]*b[7]-b[4]*b[4])+2*b[3]*b[3]*b[8];
    p[2]:=2*b[6]*(8*b[2]*b[7]-3*b[4]*b[5]+4*b[1]*b[8])+b[7]*(4*b[1]*b[7]-2*b[3]*b[5]-b[4]*b[4])+2*b[3]*b[4]*b[8];
    p[3]:=4*b[6]*(4*b[2]*b[8]-b[5]*b[5])+4*b[7]*(2*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])-2*b[4]*b[5];
    p[4]:=2*b[8]*(8*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])+b[5]*(4*b[4]-3*b[5]*b[7]);
    p[5]:=8*b[2]*b[8]*b[8]-2*b[5]*b[5]*b[8];

 if (p[0]+p[1]+p[2]+p[3]+p[4]+p[5]>0)and(5*p[0]+4*p[1]+3*p[2]+2*p[3]+p[4]>0)and(10*p[0]+6*p[1]+3*p[2]+p[3]>0)and(10*p[0]+3*p[1]+p[2]>0)and(5*p[0]+p[1]>0)and(p[0]>0) then
    begin
    result := true;
    end
 else result := false;
end;
//------------------------------------------------------------------------------
function biquadrTest4( b: biq):boolean;
var q: array[0..5] of extended;

begin
    q[0]:=4*b[3]*b[2]*b[6]+b[1]*b[1]*b[5]-2*b[1]*b[4]*b[2];
    q[1]:=2*b[2]*(4*b[2]*b[6]-2*b[1]*b[7]+4*b[3]*b[5]-b[4]*b[4])+2*b[1]*b[1]*b[8];
    q[2]:=2*b[2]*(8*b[6]*b[5]-3*b[4]*b[7]+4*b[3]*b[8])+b[5]*(4*b[3]*b[5]-2*b[1]*b[7]-b[4]*b[4])+2*b[1]*b[4]*b[8];
    q[3]:=4*b[2]*(4*b[6]*b[8]-b[7]*b[7])+4*b[5]*(2*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])-2*b[4]*b[7];
    q[4]:=2*b[8]*(8*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])+b[7]*(4*b[4]-3*b[5]*b[7]);
    q[5]:=8*b[6]*b[8]*b[8]-2*b[7]*b[7]*b[8];

 if (q[0]>0)and(q[1]>0)and(q[2]>0)and(q[3]>0)and(q[4]>0)and(q[5]>0) then
    begin
      result := true;
    end
 else result := false;
end;
//------------------------------------------------------------------------------
function biquadrTest5( b: biq):boolean;
var p: array[0..5] of extended;

begin
    p[0]:=4*b[1]*b[6]*b[6]+b[3]*b[3]*b[7]-2*b[3]*b[4]*b[6];
    p[1]:=2*b[6]*(4*b[2]*b[6]-2*b[3]*b[5]+4*b[1]*b[7]-b[4]*b[4])+2*b[3]*b[3]*b[8];
    p[2]:=2*b[6]*(8*b[2]*b[7]-3*b[4]*b[5]+4*b[1]*b[8])+b[7]*(4*b[1]*b[7]-2*b[3]*b[5]-b[4]*b[4])+2*b[3]*b[4]*b[8];
    p[3]:=4*b[6]*(4*b[2]*b[8]-b[5]*b[5])+4*b[7]*(2*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])-2*b[4]*b[5];
    p[4]:=2*b[8]*(8*b[2]*b[7]-b[4]*b[5]+2*b[1]*b[8])+b[5]*(4*b[4]-3*b[5]*b[7]);
    p[5]:=8*b[2]*b[8]*b[8]-2*b[5]*b[5]*b[8];

 if (p[0]+p[1]+p[2]+p[3]+p[4]+p[5]>0)and(p[1]+2*p[2]+3*p[3]+4*p[4]+5*p[5]<0)and(p[2]+3*p[3]+6*p[4]+10*p[5]>0)and(p[3]+4*p[4]+10*p[5]<0)and(p[4]+5*p[5]>0)and(p[5]<0) then
    begin
      result := true;
    end
 else result := false;
 end;
 //------------------------------------------------------------------------------
function biquadrTest6( b: biq):boolean;
var q: array[0..5] of extended;

begin
    q[0]:=4*b[3]*b[2]*b[6]+b[1]*b[1]*b[5]-2*b[1]*b[4]*b[2];
    q[1]:=2*b[2]*(4*b[2]*b[6]-2*b[1]*b[7]+4*b[3]*b[5]-b[4]*b[4])+2*b[1]*b[1]*b[8];
    q[2]:=2*b[2]*(8*b[6]*b[5]-3*b[4]*b[7]+4*b[3]*b[8])+b[5]*(4*b[3]*b[5]-2*b[1]*b[7]-b[4]*b[4])+2*b[1]*b[4]*b[8];
    q[3]:=4*b[2]*(4*b[6]*b[8]-b[7]*b[7])+4*b[5]*(2*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])-2*b[4]*b[7];
    q[4]:=2*b[8]*(8*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])+b[7]*(4*b[4]-3*b[5]*b[7]);
    q[5]:=8*b[6]*b[8]*b[8]-2*b[7]*b[7]*b[8];

 if (q[0]+q[1]+q[2]+q[3]+q[4]+q[5]>0)and(5*q[0]+4*q[1]+3*q[2]+2*q[3]+q[4]>0)and(10*q[0]+6*q[1]+3*q[2]+q[3]>0)and(10*q[0]+3*q[1]+q[2]>0)and(5*q[0]+q[1]>0)and(q[0]>0) then
    begin
    result := true;
    end
 else result := false;
end;
//------------------------------------------------------------------------------
function biquadrTest7( b: biq):boolean;

var q: array[0..5] of extended;

begin
    q[0]:=4*b[3]*b[2]*b[6]+b[1]*b[1]*b[5]-2*b[1]*b[4]*b[2];
    q[1]:=2*b[2]*(4*b[2]*b[6]-2*b[1]*b[7]+4*b[3]*b[5]-b[4]*b[4])+2*b[1]*b[1]*b[8];
    q[2]:=2*b[2]*(8*b[6]*b[5]-3*b[4]*b[7]+4*b[3]*b[8])+b[5]*(4*b[3]*b[5]-2*b[1]*b[7]-b[4]*b[4])+2*b[1]*b[4]*b[8];
    q[3]:=4*b[2]*(4*b[6]*b[8]-b[7]*b[7])+4*b[5]*(2*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])-2*b[4]*b[7];
    q[4]:=2*b[8]*(8*b[6]*b[5]-b[4]*b[7]+2*b[3]*b[8])+b[7]*(4*b[4]-3*b[5]*b[7]);
    q[5]:=8*b[6]*b[8]*b[8]-2*b[7]*b[7]*b[8];

 if (q[0]+q[1]+q[2]+q[3]+q[4]+q[5]>0)and(q[1]+2*q[2]+3*q[3]+4*q[4]+5*q[5]<0)and(q[2]+3*q[3]+6*q[4]+10*q[5]>0)and(q[3]+4*q[4]+10*q[5]<0)and(q[4]+5*q[5]>0)and(q[5]<0) then
    begin
    result := true;
    end
 else result := false;
end;

//------------------------------------------------------------------------------
function biquadrTest8( b: biq):boolean;
begin
	result := biquadrTest2(b) or biquadrTest3(b) or biquadrTest4(b) or biquadrTest6(b);
end;
//------------------------------------------------------------------------------
procedure addBiLin( var b: biq; a0, a1, a2, a3: extended);
begin
	b[0] := b[0] + a0*a0;
	b[1] := b[1] + 2*a0*a1;
	b[2] := b[2] + a1*a1;
	b[3] := b[3] + 2*a0*a2;
	b[4] := b[4] + 2*a0*a3 + 2*a1*a2;
	b[5] := b[5] + 2*a1*a3;
	b[6] := b[6] + a2*a2;
	b[7] := b[7] + 2*a2*a3;
	b[8] := b[8] + a3*a3;
end;
//------------------------------------------------------------------------------
procedure getBiquadr( a: matrix; ind: integer; var b: biq);
var mx: integer;
	x,y, vx, vy, sz, dx, dy,i: integer;
	a0, a1, a2, a3: extended;
begin
	mx := a.getMx;
    //my := a.getMy;
    vx := 33;
    vy := 47;
    sz :=  4;
    //  :
    y  := ind div mx;
    x  := ind mod mx;
	//  :
    for i:=0 to 8 do b[i]:=0;
	//  
    for dy:=0 to sz-1 do
   	for dx:=0 to sz-1 do begin
		a0 := a.get(x+dx+vx, y+dy)-a.get(x+dx+vx, y+dy+vy);
        a1 := a.get(x+dx+1,y)-a.get(x+dx,y+dy);
        a2 := a.get(x+dx,y+1)-a.get(x+dx,y+dy);
        a3 := a.get(x+dx+1,y+dy+1)-a.get(x+dx+1,y+dy)- a.get(x+dx,y+dy+1)+a.get(x+dx,y+dy);
        addBilin(b, a0,a1,a2,a3);
    end;
end;
//------------------------------------------------------------------------------
procedure test_01; 	// 2009-01-16  
var a: matrix;
	b: biq;
    mx, my, ind: integer;
    cnt1, cnt2, cnt3, cnt4, cnt5, cnt6, cnt7, cnt8, cnt9, cnt10: integer;
begin
	a:=matrix.Create;
	a.LoadGreyFromFile('0000.jpg');
    WriteLn('mx=', a.getMx:4, '; my=', a.getMy:4);
	mx := a.getMx;
    my := a.getMy;
    cnt1 := 0;
    cnt9 := 0;
    cnt10 := 0;
    cnt2 := 0;
    cnt3 := 0;
    cnt4 := 0;
    cnt5 := 0;
    cnt6 := 0;
    cnt7 := 0;
    cnt8 := 0;
	for ind:=0 to mx*my-1 do begin
		getBiquadr(a, ind, b);
        if biquadrTest1(b) then inc(cnt1);
        if biquadrTest9(b) then inc(cnt9);
        if biquadrTest10(b) then inc(cnt10);
        if biquadrTest2(b) then inc(cnt2);
        if biquadrTest3(b) then inc(cnt3);
        if biquadrTest4(b) then inc(cnt4);
        if biquadrTest5(b) then inc(cnt5);
        if biquadrTest6(b) then inc(cnt6);
        if biquadrTest7(b) then inc(cnt7);
        if biquadrTest8(b) then inc(cnt8);
    end;

 // WriteLn( 'tochno ne imejt min  ', cnt1:6);
 // WriteLn( 'tochno ne imejt min  ', cnt9:6);
 WriteLn( 'tochno ne imejt min  ', cnt10:6);
 WriteLn( 'ydovletvoryauchix 3 ysloviy:  ', cnt2:6);
 WriteLn( 'ydovletvoryauchix 4 ysloviy:  ', cnt3:6);
 WriteLn( 'ydovletvoryauchix 6 ysloviy:  ', cnt4:6);
 WriteLn( 'ydovletvoryauchix 5 ysloviy:  ', cnt5:6);
 WriteLn( 'ydovletvoryauchix 7 ysloviy:  ', cnt6:6);
 WriteLn( 'ydovletvoryauchix 8 ysloviy:  ', cnt7:6);
 WriteLn( 'ydovletvoryauchix vsem ysloviym:  ', cnt8:6);
    ReadLn;
end; // procedure test_01; 	// 2009-01-16  



//------------------------------------------------------------------------------
begin
	test_01;		// 2010-03-11  

end.



